import sys
import os
import shutil
import mozrunner
import jsbridge
import mozmill
from time import sleep

defaultEnv = dict(os.environ)
defaultEnv['NO_EM_RESTART'] = '1'
defaultEnv['XPCOM_DEBUG_BREAK'] = 'warn'

defaultArgs = ['-no-remote']
# for mac
defaultArgs.append('-foreground')

settings = jsbridge.get_settings()

BASE_DIR = '/Users/moztest/mozmill/tbtest/'
# *** Select and adjust based on os platform and build
APP_DIR = os.path.join(BASE_DIR, 'Shredder.app', 'Contents', 'MacOS')
#APP_DIR = os.path.join(BASE_DIR, 'thunderbird'

settings['MOZILLA_BINARY'] = os.path.join(APP_DIR, 'thunderbird-bin')
settings['MOZILLA_DEFAULT_PROFILE'] = os.path.join(APP_DIR, 'defaults', 'profile')

# XXX MOZILLA_PROFILE doesn't do anything - should it?
#settings['MOZILLA_PROFILE'] = '/Users/moztest/mozmill/tbtest/profile/'
settings['MOZILLA_CREATE_NEW_PROFILE'] = True
settings['MOZILLA_CMD_ARGS'] = defaultArgs
settings['MOZILLA_PREFERENCES'] = {
"browser.dom.window.dump.enabled": True,
"extensions.palmsync.conduitRegistered": True,
"mail.account.account1.server": "server1",
"mail.account.account2.identities": "id1",
"mail.account.account2.server" : "server2",
"mail.accountmanager.accounts" : "account1,account2",
"mail.accountmanager.defaultaccount" : "account2",
"mail.accountmanager.localfoldersserver" : "server1",
"mail.identity.id1.fullName" : "Tinderbox",
"mail.identity.id1.smtpServer" : "smtp1",
"mail.identity.id1.useremail" : "tinderbox@invalid.com",
"mail.identity.id1.valid" : True,
"mail.root.none-rel" : "[ProfD]Mail",
"mail.root.pop3-rel" : "[ProfD]Mail",
"mail.server.server1.directory-rel" : "[ProfD]Mail/Local Folders",
"mail.server.server1.hostname" : "Local Folders",
"mail.server.server1.name" : "Local Folders",
"mail.server.server1.type" : "none",
"mail.server.server1.userName" : "nobody",
"mail.server.server2.check_new_mail" : False,
"mail.server.server2.directory-rel" : "[ProfD]Mail/tinderbox",
"mail.server.server2.download_on_biff" : True,
"mail.server.server2.hostname" : "tinderbox",
"mail.server.server2.login_at_startup" : False,
"mail.server.server2.name" : "tinderbox@invalid.com",
"mail.server.server2.type" : "pop3",
"mail.server.server2.userName" : "tinderbox",
"mail.smtp.defaultserver" : "smtp1",
"mail.smtpserver.smtp1.hostname" : "tinderbox",
"mail.smtpserver.smtp1.username" : "tinderbox",
"mail.smtpservers" : "smtp1",
"mail.startup.enabledMailCheckOnce" : True,
"mailnews.start_page_override.mstone" : "ignore",
"mail.shell.checkDefaultClient" : False,
"ldap_2.servers.osx.position" : 0,
"ldap_2.servers.oe.position":  0,
}

class Thunderbird(mozrunner.runner.Mozilla):
  """Thunderbird runner class"""
  name = 'Thunderbird'

  def set_binary(self, binary):
    self.binary = binary

moz = mozrunner.get_moz_from_settings(settings, Thunderbird)

print "Starting Moz profile is " + settings['MOZILLA_PROFILE']
jsbridge.start_moz(moz, 20)
print 'jsbridge.start_moz done'
sleep(5)
mozmill.run_tests(moz, os.path.join(APP_DIR, 'test'))
print 'moz.run_tests done'
